//////////////////////////////////////////////////////////////////////
///
/// <summary>
/// </summary>
///
///
/// <remarks>
/// </remarks>
///
///
/// <copyright>
/// Your-Company. All Rights Reserved.
/// </copyright>
///
//////////////////////////////////////////////////////////////////////
#include "xbp.ch"
#include "gra.ch"
#include "common.ch"

#define DEFAULT_DPI   96

#IF XPPVER > 1900331 .AND. XPPVER < 2000000
   // Xbase++ 1.9 compatibility
   #pragma library( "xppui3.lib" )

   #ifndef XBP_RELXPOS
   #define XBP_RELXPOS                    0x10
   #define XBP_RELYPOS                    0x20
   #define XBP_RELWIDTH                   0x40
   #define XBP_RELHEIGHT                  0x80
   #define XBP_XCENTER                    0x1000
   #define XBP_YCENTER                    0x2000
   #endif
#endif

CLASS DPIScaleLayoutManager FROM LayoutManager
 PROTECTED:
   METHOD      GetTextDPI()
 EXPORTED:
   METHOD      DPIScale()
ENDCLASS


METHOD DPIScaleLayoutManager:DPIScale( oXbp )
 LOCAL aChilds
 LOCAL nFactor
 LOCAL i
 LOCAL aPos
 LOCAL aSize
 LOCAL nLen

   DEFAULT oXbp TO ::Owner

   nFactor := ::GetTextDPI() / DEFAULT_DPI
   IF nFactor == 1.0
      RETURN
   ENDIF

   aPos := oXbp:CurrentPos()
   IF oXbp:IsDerivedFrom(XbpDialog()) == .T.
      aSize := oXbp:ClientSize
   ELSE
      aSize:= oXbp:CurrentSize()
   ENDIF

   aPos[1] *= nFactor
   aPos[2] *= nFactor
   aSize[1]*= nFactor
   aSize[2]*= nFactor
   IF ::Owner == oXbp
      IF oXbp:DrawingArea:LayoutManager != NIL
         oXbp:DrawingArea:LayoutManager:Enabled := .F.
      ENDIF
      aSize := oXbp:CalcFrameRect( {0,0,aSize[1],aSize[2]} )
      oXbp:SetSize( {aSize[3],aSize[4]} )
      IF oXbp:DrawingArea:LayoutManager != NIL
         oXbp:DrawingArea:LayoutManager:Enabled := .T.
      ENDIF
   ELSE
      IF oXbp:LayoutManager != NIL
         oXbp:LayoutManager:Enabled := .F.
      ENDIF
      oXbp:SetPosAndSize( aPos, aSize )
      IF oXbp:LayoutManager != NIL
         oXbp:LayoutManager:Enabled := .T.
      ENDIF
   ENDIF

   aChilds := oXbp:ChildList()
   nLen    := Len( aChilds )
   FOR i:=1 TO nLen
      IF aChilds[i]:SetParent() == aChilds[i]:SetOwner()
         ::DPIScale( aChilds[i] )
      ENDIF
   NEXT
RETURN


METHOD DPIScaleLayoutManager:GetTextDPI()
 LOCAL oPS
 LOCAL aTmp

   oPS := XbpPresSpace():New():Create( AppDesktop():WinDevice(), ;
                                       {100,100}, GRA_PU_LOENGLISH )
   aTmp:= oPS:SetViewport()
   oPS:Destroy()
RETURN (aTmp[3]-aTmp[1])

